Index: trunk/LMDZ.GENERIC/libf/phy_common/mod_phys_lmdz_omp_transfert.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phy_common/mod_phys_lmdz_omp_transfert.F90	(revision 1542)
+++ trunk/LMDZ.GENERIC/libf/phy_common/mod_phys_lmdz_omp_transfert.F90	(revision 1543)
@@ -25,5 +25,5 @@
                      bcast_omp_i,bcast_omp_i1,bcast_omp_i2,bcast_omp_i3,bcast_omp_i4, &
                      bcast_omp_r,bcast_omp_r1,bcast_omp_r2,bcast_omp_r3,bcast_omp_r4, &
-		     bcast_omp_l,bcast_omp_l1,bcast_omp_l2,bcast_omp_l3,bcast_omp_l4
+                     bcast_omp_l,bcast_omp_l1,bcast_omp_l2,bcast_omp_l3,bcast_omp_l4
   END INTERFACE
 
@@ -31,5 +31,5 @@
     MODULE PROCEDURE scatter_omp_i,scatter_omp_i1,scatter_omp_i2,scatter_omp_i3, &
                      scatter_omp_r,scatter_omp_r1,scatter_omp_r2,scatter_omp_r3, &
-		     scatter_omp_l,scatter_omp_l1,scatter_omp_l2,scatter_omp_l3
+                     scatter_omp_l,scatter_omp_l1,scatter_omp_l2,scatter_omp_l3
   END INTERFACE
 
@@ -38,5 +38,5 @@
     MODULE PROCEDURE gather_omp_i,gather_omp_i1,gather_omp_i2,gather_omp_i3, &
                      gather_omp_r,gather_omp_r1,gather_omp_r2,gather_omp_r3, &
-		     gather_omp_l,gather_omp_l1,gather_omp_l2,gather_omp_l3  
+                     gather_omp_l,gather_omp_l1,gather_omp_l2,gather_omp_l3  
   END INTERFACE
   
@@ -48,8 +48,15 @@
 
 
-  PUBLIC bcast_omp,scatter_omp,gather_omp,reduce_sum_omp
+  PUBLIC bcast_omp,scatter_omp,gather_omp,reduce_sum_omp, omp_barrier
 
 CONTAINS
 
+  SUBROUTINE omp_barrier
+  IMPLICIT NONE
+
+!$OMP BARRIER
+
+  END SUBROUTINE omp_barrier
+  
   SUBROUTINE check_buffer_i(buff_size)
   IMPLICIT NONE
@@ -733,7 +740,7 @@
   IMPLICIT NONE
     
+    INTEGER,INTENT(IN) :: Nb
     INTEGER,DIMENSION(Nb),INTENT(INOUT) :: Var
     INTEGER,DIMENSION(Nb),INTENT(INOUT) :: Buff
-    INTEGER,INTENT(IN) :: Nb
 
     INTEGER :: i
@@ -757,7 +764,7 @@
   IMPLICIT NONE
     
+    INTEGER,INTENT(IN) :: Nb
     REAL,DIMENSION(Nb),INTENT(INOUT) :: Var
     REAL,DIMENSION(Nb),INTENT(INOUT) :: Buff
-    INTEGER,INTENT(IN) :: Nb
 
     INTEGER :: i
@@ -780,7 +787,7 @@
   IMPLICIT NONE
     
+    INTEGER,INTENT(IN) :: Nb
     LOGICAL,DIMENSION(Nb),INTENT(INOUT) :: Var
     LOGICAL,DIMENSION(Nb),INTENT(INOUT) :: Buff
-    INTEGER,INTENT(IN) :: Nb
   
     INTEGER :: i
@@ -802,5 +809,5 @@
 
   SUBROUTINE scatter_omp_igen(VarIn,VarOut,dimsize,Buff)
-    USE mod_phys_lmdz_omp_data, only: klon_omp, klon_omp_begin
+    USE mod_phys_lmdz_omp_data
     USE mod_phys_lmdz_mpi_data, ONLY : klon_mpi 
     IMPLICIT NONE
@@ -833,5 +840,5 @@
 
   SUBROUTINE scatter_omp_rgen(VarIn,VarOut,dimsize,Buff)
-  USE mod_phys_lmdz_omp_data, only: klon_omp, klon_omp_begin
+  USE mod_phys_lmdz_omp_data
   USE mod_phys_lmdz_mpi_data, ONLY : klon_mpi 
   IMPLICIT NONE
@@ -864,5 +871,5 @@
 
   SUBROUTINE scatter_omp_lgen(VarIn,VarOut,dimsize,Buff)
-  USE mod_phys_lmdz_omp_data, only: klon_omp, klon_omp_begin
+  USE mod_phys_lmdz_omp_data
   USE mod_phys_lmdz_mpi_data, ONLY : klon_mpi 
   IMPLICIT NONE
@@ -898,5 +905,5 @@
 
   SUBROUTINE gather_omp_igen(VarIn,VarOut,dimsize,Buff)
-  USE mod_phys_lmdz_omp_data, only: klon_omp, klon_omp_begin
+  USE mod_phys_lmdz_omp_data
   USE mod_phys_lmdz_mpi_data, ONLY : klon_mpi 
   IMPLICIT NONE
@@ -930,5 +937,5 @@
 
   SUBROUTINE gather_omp_rgen(VarIn,VarOut,dimsize,Buff)
-  USE mod_phys_lmdz_omp_data, only: klon_omp, klon_omp_begin
+  USE mod_phys_lmdz_omp_data
   USE mod_phys_lmdz_mpi_data, ONLY : klon_mpi 
   IMPLICIT NONE
@@ -962,5 +969,5 @@
 
   SUBROUTINE gather_omp_lgen(VarIn,VarOut,dimsize,Buff)
-  USE mod_phys_lmdz_omp_data, only: klon_omp, klon_omp_begin
+  USE mod_phys_lmdz_omp_data
   USE mod_phys_lmdz_mpi_data, ONLY : klon_mpi 
   IMPLICIT NONE
Index: trunk/LMDZ.GENERIC/libf/phy_common/mod_phys_lmdz_para.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phy_common/mod_phys_lmdz_para.F90	(revision 1542)
+++ trunk/LMDZ.GENERIC/libf/phy_common/mod_phys_lmdz_para.F90	(revision 1543)
@@ -13,16 +13,15 @@
   
 !$OMP THREADPRIVATE(klon_loc,is_master)
-!$OMP THREADPRIVATE(is_sequential,is_parallel)
   
 CONTAINS
 
-  SUBROUTINE Init_phys_lmdz_para(iim,jjp1,nb_proc,distrib)
+  SUBROUTINE Init_phys_lmdz_para(nbp,nbp_lon,nbp_lat,communicator)
   IMPLICIT NONE
-    INTEGER,INTENT(in) :: iim
-    INTEGER,INTENT(in) :: jjp1
-    INTEGER,INTENT(in) :: nb_proc
-    INTEGER,INTENT(in) :: distrib(0:nb_proc-1)
+    INTEGER,INTENT(in) :: nbp
+    INTEGER,INTENT(in) :: nbp_lon
+    INTEGER,INTENT(in) :: nbp_lat
+    INTEGER,INTENT(in) :: communicator
 
-    CALL Init_phys_lmdz_mpi_data(iim,jjp1,nb_proc,distrib)
+    CALL Init_phys_lmdz_mpi_data(nbp,nbp_lon,nbp_lat,communicator)
 !$OMP PARALLEL
     CALL Init_phys_lmdz_omp_data(klon_mpi)
@@ -46,8 +45,7 @@
 
   SUBROUTINE Test_transfert
-  USE mod_grid_phy_lmdz, only: klon_glo, nbp_lev, nbp_lon, nbp_lat, &
-                               grid1dTo2d_glo, grid2dTo1d_glo
+  USE mod_grid_phy_lmdz
   IMPLICIT NONE
-!    INCLUDE "iniprint.h"
+    INCLUDE "iniprint.h"
  
     REAL :: Test_Field1d_glo(klon_glo,nbp_lev)
@@ -83,5 +81,5 @@
 !$OMP MASTER  
       Checksum=sum(Test_Field1d_glo-tmp1d_glo)
-      WRITE(*,*) "------> Checksum =",Checksum," MUST BE 0"
+      WRITE(lunout,*) "------> Checksum =",Checksum," MUST BE 0"
 !$OMP END MASTER
     ENDIF
@@ -95,5 +93,5 @@
 !$OMP MASTER  
       Checksum=sum(Test_Field1d_glo-tmp1d_glo)
-      WRITE(*,*) "------> Checksum =",Checksum," MUST BE 0"
+      WRITE(lunout,*) "------> Checksum =",Checksum," MUST BE 0"
 !$OMP END MASTER
     ENDIF
@@ -105,5 +103,5 @@
 !$OMP MASTER  
       Checksum=sum(Test_Field1d_glo*omp_size*mpi_size-tmp1d_glo)
-      WRITE(*,*) "------> Checksum =",Checksum," MUST BE 0"
+      WRITE(lunout,*) "------> Checksum =",Checksum," MUST BE 0"
 !$OMP END MASTER
     ENDIF
Index: trunk/LMDZ.GENERIC/libf/phy_common/physics_distribution_mod.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phy_common/physics_distribution_mod.F90	(revision 1543)
+++ trunk/LMDZ.GENERIC/libf/phy_common/physics_distribution_mod.F90	(revision 1543)
@@ -0,0 +1,71 @@
+!
+!$Id: physics_distribution_mod.F90 2351 2015-08-25 15:14:59Z emillour $
+!
+MODULE physics_distribution_mod
+
+
+CONTAINS
+
+  SUBROUTINE init_physics_distribution(grid_type, nvertex, &
+                                       nbp, nbp_lon, nbp_lat, nbp_lev, &
+                                       communicator)
+  USE mod_phys_lmdz_para, ONLY: init_phys_lmdz_para
+  USE mod_grid_phy_lmdz, ONLY: init_grid_phy_lmdz
+  IMPLICIT NONE
+    INTEGER,INTENT(IN) :: grid_type 
+    INTEGER,INTENT(IN) :: nvertex 
+    INTEGER,INTENT(IN) :: nbp           
+    INTEGER,INTENT(IN) :: nbp_lon
+    INTEGER,INTENT(IN) :: nbp_lat
+    INTEGER,INTENT(IN) :: nbp_lev
+    INTEGER,INTENT(IN) :: communicator
+
+
+    CALL init_grid_phy_lmdz(grid_type,nvertex, nbp_lon,nbp_lat,nbp_lev)
+    CALL init_phys_lmdz_para(nbp,nbp_lon, nbp_lat, communicator)
+
+  END SUBROUTINE init_physics_distribution  
+
+!SUBROUTINE Init_Phys_lmdz(iim,jjp1,llm,nb_proc,distrib)
+!  USE mod_phys_lmdz_para, ONLY: Init_phys_lmdz_para!, klon_omp
+!  USE mod_grid_phy_lmdz, ONLY: Init_grid_phy_lmdz!, nbp_lev
+!  USE dimphy, ONLY : Init_dimphy
+!  USE infotrac_phy, ONLY : type_trac
+!#ifdef REPROBUS
+!  USE CHEM_REP, ONLY : Init_chem_rep_phys
+!#endif
+
+!  IMPLICIT NONE
+  
+!    INTEGER,INTENT(in) :: iim
+!    INTEGER,INTENT(in) :: jjp1
+!    INTEGER,INTENT(in) :: llm
+!    INTEGER,INTENT(in) :: nb_proc
+!    INTEGER,INTENT(in) :: distrib(0:nb_proc-1)
+
+
+!    CALL Init_grid_phy_lmdz(iim,jjp1,llm)
+!    CALL Init_phys_lmdz_para(iim,jjp1,nb_proc,distrib)
+!!$OMP PARALLEL
+!    CALL Init_dimphy(klon_omp,nbp_lev)
+!
+!! Initialization of Reprobus
+!    IF (type_trac == 'repr') THEN
+!#ifdef REPROBUS
+!       CALL Init_chem_rep_phys(klon_omp,nbp_lev)
+!#endif
+!    END IF
+!
+!!$OMP END PARALLEL
+ 
+!END SUBROUTINE Init_Phys_lmdz  
+
+
+
+
+
+
+
+
+END MODULE physics_distribution_mod
+
Index: trunk/LMDZ.GENERIC/libf/phystd/condense_co2.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/condense_co2.F90	(revision 1542)
+++ trunk/LMDZ.GENERIC/libf/phystd/condense_co2.F90	(revision 1543)
@@ -11,5 +11,5 @@
       use aerosol_mod, only : iaero_co2
       USE surfdat_h, only: emisice, emissiv
-      USE comgeomphy, only: latitude ! in radians
+      USE geometry_mod, only: latitude ! in radians
       USE tracer_h, only: noms, rho_co2
       use comcstfi_mod, only: g, r, cpp
Index: trunk/LMDZ.GENERIC/libf/phystd/dyn1d/mod_interface_dyn_phys.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/dyn1d/mod_interface_dyn_phys.F90	(revision 1543)
+++ trunk/LMDZ.GENERIC/libf/phystd/dyn1d/mod_interface_dyn_phys.F90	(revision 1543)
@@ -0,0 +1,1 @@
+link ../../dynphy_lonlat/mod_interface_dyn_phys.F90
Index: trunk/LMDZ.GENERIC/libf/phystd/dyn1d/rcm1d.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/dyn1d/rcm1d.F	(revision 1542)
+++ trunk/LMDZ.GENERIC/libf/phystd/dyn1d/rcm1d.F	(revision 1543)
@@ -3,4 +3,6 @@
 ! to use  'getin'
       use ioipsl_getincom, only: getin
+      use dimphy, only : init_dimphy
+      use mod_grid_phy_lmdz, only : regular_lonlat
       use infotrac, only: nqtot, tname
       use surfdat_h, only: albedodat, phisfi, dryness, watercaptag,
@@ -9,8 +11,7 @@
      &                     dtemisice
       use comdiurn_h, only: sinlat, coslat, sinlon, coslon
-!      use comsaison_h
       use comsoil_h, only: nsoilmx, layer, mlayer, inertiedat, volcapa
       use phyredem, only: physdem0,physdem1
-      use comgeomphy, only: initcomgeomphy, cell_area
+      use geometry_mod, only: init_geometry
       use slab_ice_h, only: noceanmx
       use planete_mod, only: apoastr,periastr,year_day,peri_day,
@@ -27,4 +28,7 @@
       use regular_lonlat_mod, only: init_regular_lonlat
       use planete_mod, only: ini_planete_mod
+      use physics_distribution_mod, only: init_physics_distribution
+      use regular_lonlat_mod, only: init_regular_lonlat
+      use mod_interface_dyn_phys, only: init_interface_dyn_phys
       use inifis_mod, only: inifis
       implicit none
@@ -133,5 +137,5 @@
       character*20,allocatable :: nametrac(:)   ! name of the tracer (no need for adv trac common)
 
-      real :: latitude(1), longitude(1)
+      real :: latitude(1), longitude(1), cell_area(1)
 
 c=======================================================================
@@ -140,6 +144,6 @@
 ! initialize "serial/parallel" related stuff
 !      CALL init_phys_lmdz(iim,jjm+1,llm,1,(/(jjm-1)*iim+2/))
-      CALL init_phys_lmdz(1,1,llm,1,(/1/))
-      call initcomgeomphy
+!      CALL init_phys_lmdz(1,1,llm,1,(/1/))
+!      call initcomgeomphy
 
       !! those are defined in surfdat_h.F90
@@ -490,7 +494,13 @@
 
       ! initializations, as with iniphysiq.F90 for the 3D GCM
+      call init_physics_distribution(regular_lonlat,4,
+     &                               1,1,1,nlayer,1)
+      call init_interface_dyn_phys
       CALL init_regular_lonlat(1,1,longitude,latitude,
      &                   (/0.,0./),(/0.,0./))
-      
+      call init_geometry(1,longitude,latitude,
+     &                   (/0.,0.,0.,0./),(/0.,0.,0.,0./),
+     &                   cell_area)
+      call init_dimphy(1,nlayer) ! Initialize dimphy module
       call ini_planete_mod(nlayer,preff,ap,bp)
 
Index: trunk/LMDZ.GENERIC/libf/phystd/hydrol.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/hydrol.F90	(revision 1542)
+++ trunk/LMDZ.GENERIC/libf/phystd/hydrol.F90	(revision 1543)
@@ -10,5 +10,5 @@
   USE surfdat_h
   use comdiurn_h
-  USE comgeomphy, only: cell_area
+  USE geometry_mod, only: cell_area
   USE tracer_h
   use slab_ice_h
Index: trunk/LMDZ.GENERIC/libf/phystd/phyredem.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/phyredem.F90	(revision 1542)
+++ trunk/LMDZ.GENERIC/libf/phystd/phyredem.F90	(revision 1543)
@@ -10,5 +10,5 @@
 ! create physics restart file and write time-independent variables
   use comsoil_h, only: volcapa, mlayer
-  use comgeomphy, only: cell_area
+  use geometry_mod, only: cell_area
   use surfdat_h, only: zmea, zstd, zsig, zgam, zthe, &
                        emisice, emissiv,             &
Index: trunk/LMDZ.GENERIC/libf/phystd/physiq.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 1542)
+++ trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 1543)
@@ -19,5 +19,5 @@
       use comsaison_h, only: mu0, fract, dist_star, declin, right_ascen
       use comsoil_h, only: nsoilmx, layer, mlayer, inertiedat
-      use comgeomphy, only: latitude, longitude, cell_area
+      use geometry_mod, only: latitude, longitude, cell_area
       USE comgeomfi_h, only: totarea, totarea_planet
       USE tracer_h, only: noms, mmol, radius, rho_q, qext, &
Index: trunk/LMDZ.GENERIC/libf/phystd/rings.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/rings.F90	(revision 1542)
+++ trunk/LMDZ.GENERIC/libf/phystd/rings.F90	(revision 1543)
@@ -5,5 +5,5 @@
 
     use comdiurn_h, only: sinlat, sinlon, coslat, coslon
-    use comgeomphy, only: latitude ! (rad)
+    use geometry_mod, only: latitude ! (rad)
  
     implicit none   
Index: trunk/LMDZ.GENERIC/libf/phystd/soil.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/soil.F	(revision 1542)
+++ trunk/LMDZ.GENERIC/libf/phystd/soil.F	(revision 1543)
@@ -8,5 +8,5 @@
       use time_phylmdz_mod, only: daysec
       use planete_mod, only: year_day
-      use comgeomphy, only: longitude, latitude ! in radians
+      use geometry_mod, only: longitude, latitude ! in radians
 
       implicit none
Index: trunk/LMDZ.GENERIC/libf/phystd/surface_nature.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/surface_nature.F	(revision 1542)
+++ trunk/LMDZ.GENERIC/libf/phystd/surface_nature.F	(revision 1543)
@@ -4,5 +4,5 @@
       USE surfdat_h
       USE comsoil_h
-      USE comgeomphy, ONLY: cell_area
+      USE geometry_mod, ONLY: cell_area
       USE tracer_h
 
Index: trunk/LMDZ.GENERIC/libf/phystd/writediagfi.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/writediagfi.F	(revision 1542)
+++ trunk/LMDZ.GENERIC/libf/phystd/writediagfi.F	(revision 1543)
@@ -40,5 +40,5 @@
 !=================================================================
       use surfdat_h, only: phisfi
-      use comgeomphy, only: cell_area
+      use geometry_mod, only: cell_area
       use time_phylmdz_mod, only: ecritphy, day_step, iphysiq, day_ini
       USE mod_phys_lmdz_para, only : is_parallel, is_mpi_root,
Index: trunk/LMDZ.GENERIC/libf/phystd/writediagsoil.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/writediagsoil.F90	(revision 1542)
+++ trunk/LMDZ.GENERIC/libf/phystd/writediagsoil.F90	(revision 1543)
@@ -13,5 +13,5 @@
 
 use comsoil_h, only: nsoilmx, inertiedat
-use comgeomphy, only: cell_area
+use geometry_mod, only: cell_area
 use time_phylmdz_mod, only: ecritphy, day_step, iphysiq
 use mod_phys_lmdz_para, only : is_mpi_root, is_master, gather
Index: trunk/LMDZ.GENERIC/libf/phystd/writediagspecIR.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/writediagspecIR.F	(revision 1542)
+++ trunk/LMDZ.GENERIC/libf/phystd/writediagspecIR.F	(revision 1543)
@@ -43,5 +43,5 @@
 ! Addition by RW (2010) to allow OLR to be saved in .nc format
       use radinc_h, only : L_NSPECTI
-      use comgeomphy, only: cell_area
+      use geometry_mod, only: cell_area
       use mod_phys_lmdz_para, only : is_mpi_root, is_master, gather
       use mod_grid_phy_lmdz, only : klon_glo, Grid1Dto2D_glo,
Index: trunk/LMDZ.GENERIC/libf/phystd/writediagspecVI.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/writediagspecVI.F	(revision 1542)
+++ trunk/LMDZ.GENERIC/libf/phystd/writediagspecVI.F	(revision 1543)
@@ -43,5 +43,5 @@
 ! Addition by RW (2010) to allow OSR to be saved in .nc format
       use radinc_h, only : L_NSPECTV
-      use comgeomphy, only: cell_area
+      use geometry_mod, only: cell_area
       use mod_phys_lmdz_para, only : is_mpi_root, is_master, gather
       use mod_grid_phy_lmdz, only : klon_glo, Grid1Dto2D_glo,
Index: trunk/LMDZ.MARS/README
===================================================================
--- trunk/LMDZ.MARS/README	(revision 1542)
+++ trunk/LMDZ.MARS/README	(revision 1543)
@@ -2270,2 +2270,9 @@
    comgeomphy.F90 instead
 
+== 22/04/2016 == EM
+- Updates and cleanup wrt dynamics/physics separation:
+  Removed init_phys_lmdz.F90 and comgeomphy.F90 from phymars;
+  comgeomphy is replaced by geometry_mod (located in phy_common).
+  Added physics_distribution_mod.F90 in phy_common and
+  mod_interface_dyn_phys.F90 in dynphy_lonlat.
+  Added nrtype.F90 (contains math const. like PI, etc.) in "misc"
Index: trunk/LMDZ.MARS/libf/aeronomars/moldiff_red.F90
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/moldiff_red.F90	(revision 1542)
+++ trunk/LMDZ.MARS/libf/aeronomars/moldiff_red.F90	(revision 1543)
@@ -3,5 +3,5 @@
 
 use tracer_mod, only: noms, mmol
-use comgeomphy, only: cell_area
+use geometry_mod, only: cell_area
 
 implicit none
Index: trunk/LMDZ.MARS/libf/dyn3d/gcm.F
===================================================================
--- trunk/LMDZ.MARS/libf/dyn3d/gcm.F	(revision 1542)
+++ trunk/LMDZ.MARS/libf/dyn3d/gcm.F	(revision 1543)
@@ -7,4 +7,5 @@
       use filtreg_mod, only: inifilr
 !      use comgeomphy, only: initcomgeomphy
+      USE mod_const_mpi, ONLY: COMM_LMDZ
       USE comvert_mod, ONLY: ap,bp
       USE comconst_mod, ONLY: daysec,dtvr,dtphys,dtdiss,rad,g,r,cpp
@@ -160,14 +161,4 @@
 c-----------------------------------------------------------------------
       CALL defrun_new( 99, .TRUE. )
-
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-! FH 2008/05/02
-! A nettoyer. On ne veut qu'une ou deux routines d'interface 
-! dynamique -> physique pour l'initialisation
-!#ifdef CPP_PHYS
-      CALL init_phys_lmdz(iim,jjp1,llm,1,(/(jjm-1)*iim+2/))
-!      call initcomgeomphy ! now done in iniphysiq
-!#endif
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
 ! Initialize tracers
@@ -254,5 +245,7 @@
 !#ifdef CPP_PHYS
 !         CALL iniphysiq(iim,jjm,llm,daysec,day_ini,dtphys/nsplit_phys,
-         CALL iniphysiq(iim,jjm,llm,daysec,day_ini,dtphys,
+         CALL iniphysiq(iim,jjm,llm,
+     &                  (jjm-1)*iim+2,comm_lmdz,
+     &                  daysec,day_ini,dtphys,
      &                  rlatu,rlatv,rlonu,rlonv,
      &                  aire,cu,cv,rad,g,r,cpp,
Index: trunk/LMDZ.MARS/libf/dynphy_lonlat/mod_interface_dyn_phys.F90
===================================================================
--- trunk/LMDZ.MARS/libf/dynphy_lonlat/mod_interface_dyn_phys.F90	(revision 1543)
+++ trunk/LMDZ.MARS/libf/dynphy_lonlat/mod_interface_dyn_phys.F90	(revision 1543)
@@ -0,0 +1,62 @@
+! 
+! $Id: mod_interface_dyn_phys.F90 2351 2015-08-25 15:14:59Z emillour $
+!
+MODULE mod_interface_dyn_phys
+  INTEGER,SAVE,dimension(:),allocatable :: index_i
+  INTEGER,SAVE,dimension(:),allocatable :: index_j
+  
+  
+CONTAINS
+  
+#ifdef CPP_PARA
+! Interface with parallel physics,
+  SUBROUTINE Init_interface_dyn_phys
+    USE mod_phys_lmdz_mpi_data
+    IMPLICIT NONE
+    include 'dimensions.h'    
+    
+    INTEGER :: i,j,k
+    
+    ALLOCATE(index_i(klon_mpi))
+    ALLOCATE(index_j(klon_mpi))
+    
+    k=1
+    IF (is_north_pole) THEN
+      index_i(k)=1
+      index_j(k)=1
+      k=2
+    ELSE
+      DO i=ii_begin,iim
+	index_i(k)=i
+	index_j(k)=jj_begin
+	k=k+1
+       ENDDO
+    ENDIF
+    
+    DO j=jj_begin+1,jj_end-1
+      DO i=1,iim
+	index_i(k)=i
+	index_j(k)=j
+	k=k+1
+      ENDDO
+    ENDDO
+    
+    IF (is_south_pole) THEN
+      index_i(k)=1
+      index_j(k)=jj_end
+    ELSE
+      DO i=1,ii_end
+	index_i(k)=i
+	index_j(k)=jj_end
+	k=k+1
+       ENDDO
+    ENDIF
+  
+  END SUBROUTINE Init_interface_dyn_phys 
+#else
+  SUBROUTINE Init_interface_dyn_phys
+  ! dummy routine for seq case
+  END SUBROUTINE Init_interface_dyn_phys 
+#endif
+! of #ifdef CPP_PARA
+END MODULE mod_interface_dyn_phys
Index: trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/iniphysiq_mod.F90
===================================================================
--- trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/iniphysiq_mod.F90	(revision 1542)
+++ trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/iniphysiq_mod.F90	(revision 1543)
@@ -3,30 +3,34 @@
 CONTAINS
 
-subroutine iniphysiq(ii,jj,nlayer,punjours, pdayref,ptimestep,           &
-                     rlatu,rlatv,rlonu,rlonv,aire,cu,cv,                 &
+subroutine iniphysiq(ii,jj,nlayer, &
+                     nbp, communicator, &
+                     punjours, pdayref,ptimestep, &
+                     rlatu,rlatv,rlonu,rlonv,aire,cu,cv, &
                      prad,pg,pr,pcpp,iflag_phys)
 
-use dimphy, only : klev ! number of atmospheric levels
-use mod_grid_phy_lmdz, only : klon_glo ! number of atmospheric columns
-                                       ! (on full grid)
+use dimphy, only : init_dimphy
+use mod_grid_phy_lmdz, only : klon_glo, & ! number of atmospheric columns (on full grid)
+                              regular_lonlat  ! regular longitude-latitude grid type
 use mod_phys_lmdz_para, only : klon_omp, & ! number of columns (on local omp grid)
                                klon_omp_begin, & ! start index of local omp subgrid
                                klon_omp_end, & ! end index of local omp subgrid
                                klon_mpi_begin ! start indes of columns (on local mpi grid)
-
-use comgeomphy, only : initcomgeomphy, &
-                       cell_area, & ! physics grid area (m2)
-                       dx, & ! cu coeff. (u_covariant = cu * u)
-                       dy, & ! cv coeff. (v_covariant = cv * v)
-                       longitude, & ! longitudes (rad)
-                       latitude ! latitudes (rad)
+use geometry_mod, only: init_geometry
+!use comgeomphy, only : initcomgeomphy, &
+!                       cell_area, & ! physics grid area (m2)
+!                       dx, & ! cu coeff. (u_covariant = cu * u)
+!                       dy, & ! cv coeff. (v_covariant = cv * v)
+!                       longitude, & ! longitudes (rad)
+!                       latitude ! latitudes (rad)
 use infotrac, only : nqtot ! number of advected tracers
 use comgeomfi_h, only: ini_fillgeom
 use temps_mod, only: day_ini, hour_ini
 use phys_state_var_init_mod, only: phys_state_var_init
+use physics_distribution_mod, only: init_physics_distribution
 use regular_lonlat_mod, only: init_regular_lonlat, &
                               east, west, north, south, &
                               north_east, north_west, &
                               south_west, south_east
+use mod_interface_dyn_phys, only: init_interface_dyn_phys
 
 implicit none
@@ -43,4 +47,6 @@
 integer,intent(in) :: ii ! number of atmospheric coulumns along longitudes
 integer,intent(in) :: jj  ! number of atompsheric columns along latitudes
+integer,intent(in) :: nbp ! number of physics columns for this MPI process
+integer,intent(in) :: communicator ! MPI communicator
 real,intent(in) :: rlatu(jj+1) ! latitudes of the physics grid
 real,intent(in) :: rlatv(jj) ! latitude boundaries of the physics grid
@@ -55,5 +61,5 @@
 
 integer :: ibegin,iend,offset
-integer :: i,j
+integer :: i,j,k
 character(len=20) :: modname='iniphysiq'
 character(len=80) :: abort_message
@@ -66,29 +72,29 @@
 
 ! global array, on full physics grid:
-real,allocatable :: latfi(:)
-real,allocatable :: lonfi(:)
-real,allocatable :: cufi(:)
-real,allocatable :: cvfi(:)
-real,allocatable :: airefi(:)
+real,allocatable :: latfi_glo(:)
+real,allocatable :: lonfi_glo(:)
+real,allocatable :: cufi_glo(:)
+real,allocatable :: cvfi_glo(:)
+real,allocatable :: airefi_glo(:)
+real,allocatable :: boundslonfi_glo(:,:)
+real,allocatable :: boundslatfi_glo(:,:)
+
+! local arrays, on given MPI/OpenMP domain:
+real,allocatable,save :: latfi(:)
+real,allocatable,save :: lonfi(:)
+real,allocatable,save :: cufi(:)
+real,allocatable,save :: cvfi(:)
+real,allocatable,save :: airefi(:)
+real,allocatable,save :: boundslonfi(:,:)
+real,allocatable,save :: boundslatfi(:,:)
+!$OMP THREADPRIVATE (latfi,lonfi,cufi,cvfi,airefi,boundslonfi,boundslatfi)
+
 
 pi=2.*asin(1.0)
 
-IF (nlayer.NE.klev) THEN
-  write(*,*) 'STOP in ',trim(modname)
-  write(*,*) 'Problem with dimensions :'
-  write(*,*) 'nlayer     = ',nlayer
-  write(*,*) 'klev   = ',klev
-  abort_message = ''
-  CALL abort_gcm (modname,abort_message,1)
-ENDIF
-
-!IF (ngrid.NE.klon_glo) THEN
-!  write(*,*) 'STOP in ',trim(modname)
-!  write(*,*) 'Problem with dimensions :'
-!  write(*,*) 'ngrid     = ',ngrid
-!  write(*,*) 'klon   = ',klon_glo
-!  abort_message = ''
-!  CALL abort_gcm (modname,abort_message,1)
-!ENDIF
+! Initialize Physics distibution and parameters and interface with dynamics
+CALL init_physics_distribution(regular_lonlat,4, &
+                                 nbp,ii,jj+1,nlayer,communicator)
+CALL init_interface_dyn_phys
 
 ! init regular global longitude-latitude grid points and boundaries
@@ -115,32 +121,63 @@
 
 ! Generate global arrays on full physics grid
-allocate(latfi(klon_glo),lonfi(klon_glo),cufi(klon_glo),cvfi(klon_glo))
-latfi(1)=rlatu(1)
-lonfi(1)=0.
-cufi(1) = cu(1)
-cvfi(1) = cv(1)
+allocate(latfi_glo(klon_glo),lonfi_glo(klon_glo))
+allocate(cufi_glo(klon_glo),cvfi_glo(klon_glo))
+allocate(airefi_glo(klon_glo))
+allocate(boundslonfi_glo(klon_glo,4))
+allocate(boundslatfi_glo(klon_glo,4))
+
+! North pole
+latfi_glo(1)=rlatu(1)
+lonfi_glo(1)=0.
+cufi_glo(1) = cu(1)
+cvfi_glo(1) = cv(1)
+boundslonfi_glo(1,north_east)=0
+boundslatfi_glo(1,north_east)=PI/2
+boundslonfi_glo(1,north_west)=2*PI
+boundslatfi_glo(1,north_west)=PI/2
+boundslonfi_glo(1,south_west)=2*PI
+boundslatfi_glo(1,south_west)=rlatv(1)
+boundslonfi_glo(1,south_east)=0
+boundslatfi_glo(1,south_east)=rlatv(1)
 DO j=2,jj
   DO i=1,ii
-    latfi((j-2)*ii+1+i)= rlatu(j)
-    lonfi((j-2)*ii+1+i)= rlonv(i)
-    cufi((j-2)*ii+1+i) = cu((j-1)*(ii+1)+i)
-    cvfi((j-2)*ii+1+i) = cv((j-1)*(ii+1)+i)
+    k=(j-2)*ii+1+i
+    latfi_glo((j-2)*ii+1+i)= rlatu(j)
+    lonfi_glo((j-2)*ii+1+i)= rlonv(i)
+    cufi_glo((j-2)*ii+1+i) = cu((j-1)*(ii+1)+i)
+    cvfi_glo((j-2)*ii+1+i) = cv((j-1)*(ii+1)+i)
+    boundslonfi_glo(k,north_east)=rlonu(i)
+    boundslatfi_glo(k,north_east)=rlatv(j-1)
+    boundslonfi_glo(k,north_west)=rlonu(i+1)
+    boundslatfi_glo(k,north_west)=rlatv(j-1)
+    boundslonfi_glo(k,south_west)=rlonu(i+1)
+    boundslatfi_glo(k,south_west)=rlatv(j)
+    boundslonfi_glo(k,south_east)=rlonu(i)
+    boundslatfi_glo(k,south_east)=rlatv(j)
   ENDDO
 ENDDO
-latfi(klon_glo)= rlatu(jj+1)
-lonfi(klon_glo)= 0.
-cufi(klon_glo) = cu((ii+1)*jj+1)
-cvfi(klon_glo) = cv((ii+1)*jj-ii)
+! South pole
+latfi_glo(klon_glo)= rlatu(jj+1)
+lonfi_glo(klon_glo)= 0.
+cufi_glo(klon_glo) = cu((ii+1)*jj+1)
+cvfi_glo(klon_glo) = cv((ii+1)*jj-ii)
+boundslonfi_glo(klon_glo,north_east)= 0
+boundslatfi_glo(klon_glo,north_east)= rlatv(jj)
+boundslonfi_glo(klon_glo,north_west)= 2*PI
+boundslatfi_glo(klon_glo,north_west)= rlatv(jj)
+boundslonfi_glo(klon_glo,south_west)= 2*PI
+boundslatfi_glo(klon_glo,south_west)= -PI/2
+boundslonfi_glo(klon_glo,south_east)= 0
+boundslatfi_glo(klon_glo,south_east)= -Pi/2
 
 ! build airefi(), mesh area on physics grid
-allocate(airefi(klon_glo))
-CALL gr_dyn_fi(1,ii+1,jj+1,klon_glo,aire,airefi)
+CALL gr_dyn_fi(1,ii+1,jj+1,klon_glo,aire,airefi_glo)
 ! Poles are single points on physics grid
-airefi(1)=sum(aire(1:ii,1))
-airefi(klon_glo)=sum(aire(1:ii,jj+1))
+airefi_glo(1)=sum(aire(1:ii,1))
+airefi_glo(klon_glo)=sum(aire(1:ii,jj+1))
 
 ! Sanity check: do total planet area match between physics and dynamics?
 total_area_dyn=sum(aire(1:ii,1:jj+1))
-total_area_phy=sum(airefi(1:klon_glo))
+total_area_phy=sum(airefi_glo(1:klon_glo))
 IF (total_area_dyn/=total_area_phy) THEN
   WRITE (lunout, *) 'iniphysiq: planet total surface discrepancy !!!'
@@ -158,22 +195,31 @@
 !$OMP PARALLEL 
 ! Now generate local lon/lat/cu/cv/area arrays
-call initcomgeomphy
-
-!!!!$OMP PARALLEL PRIVATE(ibegin,iend) 
-!!!$OMP+         SHARED(parea,pcu,pcv,plon,plat)
+allocate(latfi(klon_omp),lonfi(klon_omp),cufi(klon_omp),cvfi(klon_omp))
+allocate(airefi(klon_omp))
+allocate(boundslonfi(klon_omp,4))
+allocate(boundslatfi(klon_omp,4))
+!call initcomgeomphy
       
 offset=klon_mpi_begin-1
-cell_area(1:klon_omp)=airefi(offset+klon_omp_begin:offset+klon_omp_end)
-dx(1:klon_omp)=cufi(offset+klon_omp_begin:offset+klon_omp_end)
-dy(1:klon_omp)=cvfi(offset+klon_omp_begin:offset+klon_omp_end)
-longitude(1:klon_omp)=lonfi(offset+klon_omp_begin:offset+klon_omp_end)
-latitude(1:klon_omp)=latfi(offset+klon_omp_begin:offset+klon_omp_end)
+airefi(1:klon_omp)=airefi_glo(offset+klon_omp_begin:offset+klon_omp_end)
+cufi(1:klon_omp)=cufi_glo(offset+klon_omp_begin:offset+klon_omp_end)
+cvfi(1:klon_omp)=cvfi_glo(offset+klon_omp_begin:offset+klon_omp_end)
+lonfi(1:klon_omp)=lonfi_glo(offset+klon_omp_begin:offset+klon_omp_end)
+latfi(1:klon_omp)=latfi_glo(offset+klon_omp_begin:offset+klon_omp_end)
+boundslonfi(1:klon_omp,:)=boundslonfi_glo(offset+klon_omp_begin:offset+klon_omp_end,:)
+boundslatfi(1:klon_omp,:)=boundslatfi_glo(offset+klon_omp_begin:offset+klon_omp_end,:)
+
+! copy over local grid longitudes and latitudes
+CALL init_geometry(klon_omp,lonfi,latfi,boundslonfi,boundslatfi, &
+                   airefi,cufi,cvfi)
 
 ! copy some fundamental parameters to physics 
 ! and do some initializations 
+
+call init_dimphy(klon_omp,nlayer) ! Initialize dimphy module
 call phys_state_var_init(klon_omp,nlayer,nqtot, &
                          day_ini,hour_ini,punjours,ptimestep, &
                          prad,pg,pr,pcpp)
-call ini_fillgeom(klon_omp,latitude,longitude,cell_area)
+call ini_fillgeom(klon_omp,latfi,lonfi,airefi)
 call conf_phys(klon_omp,nlayer,nqtot)
 
